/******************************************************************************/
//
// Name: 	Interfacing ADSP-21365 with AD7865 
//
/******************************************************************************

(C) Copyright 2004 - Analog Devices, Inc.  All rights reserved.

File Name:		ADSP-21365_with_AD7865_DMA.asm

Date Modified:	11/05/04				Rev 1.0

Software:       VisualDSP++3.5 (September update)

Purpose:		To receive data from AD7865
				
*******************************************************************************/

#include <def21365.h>
#include <SRU.h>

.section/pm seg_rth;
	nop;nop;nop;nop;
 	nop;jump start;nop;nop;

.section/pm seg_irq;
	jump irq_isr;rti;rti;rti;
		
.section/dm seg_dmda;
	.var channel_data[2];
	.var rearranged_data[4];
		
.section/pm seg_pmco;
start:
	SRU(SPORT0_FS_O,DAI_PB05_I);
	SRU(HIGH,PBEN05_I);

	bit set FLAGS FLG0O | FLG0;
	ustat1 = dm(SYSCTL);
	bit set ustat1 IRQ1EN;
	dm(SYSCTL) = ustat1;
	bit set mode2 IRQ1E;
	nop;nop;nop;nop;
	bit clr irptl IRQ1I;
	bit set imask IRQ1I;
	bit set mode1 IRPTEN;

	r0 = 0x0;
	dm(SPCTL0) = r0;
		
	r0 = 0x6f001f;
	dm(DIV0) = r0;
	
	// Dummy write to initiate TFS
	r0 = 0xaaaaaaaa;
	dm(TXSP0A) = r0;
	
	r0 = SPEN_A | SLEN32 | ICLK | IFS | FSR | DITFS | LFS | SPTRAN;
	dm(SPCTL0) = r0;
		
	r1 = 0x3fff;
	nop;
	nop;
	jump(pc,0);
	
	
irq_isr:
	r0 = 0x0;
	dm(PPCTL) = r0;

	r0 = channel_data;
	dm(IIPP) = r0;

	r0 = 1;
	dm(IMPP) = r0;
	
	r0 = 2;
	dm(ICPP) = r0;

	r0 = 0;
	dm(EIPP) = r0;

	r0 = 1;
	dm(EMPP) = r0;
	
	r0 = 4;
	dm(ECPP) = r0;	
	
	// Initializing DMA
	r0 = PPEN | PPDUR32 | PP16 | PPDEN;
	dm(PPCTL) = r0;

	bit clr FLAGS FLG0;

	nop;nop;nop;nop;nop;
	nop;nop;nop;nop;nop;
	nop;nop;nop;nop;nop;
	poll: 
 		r0 = dm(PPCTL);
		r1 = 0x30000;
		r0 = r0 and r1;
		r0 = pass r0;
		if ne jump poll;

	bit set FLAGS FLG0;
	
	r1 = 0xffff;
	r2 = 0xffff0000;
	r3 = dm(channel_data);
	r0 = r3 and r1;
	dm(rearranged_data) = r0;
	
	r0 = r3 and r2;
	r0 = lshift r0 by -16;
	dm(rearranged_data+1) = r0;
	
	r3 = dm(channel_data+1);
	r0 = r3 and r1;
	dm(rearranged_data+2) = r0;
	
	r0 = r3 and r2;
	r0 = lshift r0 by -16;
	dm(rearranged_data+3) = r0;
	
	rti;